<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Matrices</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Cogl 2.0 Reference Manual">
<link rel="up" href="cogl-utilities.html" title="Utilities">
<link rel="prev" href="cogl-2.0-experimental-Color-Type.html" title="Color Type">
<link rel="next" href="cogl-2.0-experimental-Matrix-Stacks.html" title="Matrix Stacks">
<meta name="generator" content="GTK-Doc V1.18.1 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2">
<tr valign="middle">
<td><a accesskey="p" href="cogl-2.0-experimental-Color-Type.html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td><a accesskey="u" href="cogl-utilities.html"><img src="up.png" width="24" height="24" border="0" alt="Up"></a></td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">Cogl 2.0 Reference Manual</th>
<td><a accesskey="n" href="cogl-2.0-experimental-Matrix-Stacks.html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr>
<tr><td colspan="5" class="shortcuts">
<a href="#cogl-2.0-experimental-Matrices.synopsis" class="shortcut">Top</a>
                   | 
                  <a href="#cogl-2.0-experimental-Matrices.description" class="shortcut">Description</a>
</td></tr>
</table>
<div class="refentry">
<a name="cogl-2.0-experimental-Matrices"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="cogl-2.0-experimental-Matrices.top_of_page"></a>Matrices</span></h2>
<p>Matrices — Functions for initializing and manipulating 4x4 matrices</p>
</td>
<td valign="top" align="right"></td>
</tr></table></div>
<div class="refsynopsisdiv">
<a name="cogl-2.0-experimental-Matrices.synopsis"></a><h2>Synopsis</h2>
<pre class="synopsis">                    <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix">CoglMatrix</a>;
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-init-identity" title="cogl_matrix_init_identity ()">cogl_matrix_init_identity</a>           (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-init-from-array" title="cogl_matrix_init_from_array ()">cogl_matrix_init_from_array</a>         (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code>const <span class="type">float</span> *array</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-init-translation" title="cogl_matrix_init_translation ()">cogl_matrix_init_translation</a>        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> tx</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> ty</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> tz</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-init-from-quaternion" title="cogl_matrix_init_from_quaternion ()">cogl_matrix_init_from_quaternion</a>    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-init-from-euler" title="cogl_matrix_init_from_euler ()">cogl_matrix_init_from_euler</a>         (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>);
<a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="returnvalue">CoglMatrix</span></a> *        <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-copy" title="cogl_matrix_copy ()">cogl_matrix_copy</a>                    (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-equal" title="cogl_matrix_equal ()">cogl_matrix_equal</a>                   (<em class="parameter"><code>const <span class="type">void</span> *v1</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *v2</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-free" title="cogl_matrix_free ()">cogl_matrix_free</a>                    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-frustum" title="cogl_matrix_frustum ()">cogl_matrix_frustum</a>                 (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> left</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> right</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> bottom</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> top</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z_near</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z_far</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-orthographic" title="cogl_matrix_orthographic ()">cogl_matrix_orthographic</a>            (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x_1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y_1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x_2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y_2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> near</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> far</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-perspective" title="cogl_matrix_perspective ()">cogl_matrix_perspective</a>             (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> fov_y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> aspect</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z_near</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z_far</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-look-at" title="cogl_matrix_look_at ()">cogl_matrix_look_at</a>                 (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> eye_position_x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> eye_position_y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> eye_position_z</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> object_x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> object_y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> object_z</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> world_up_x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> world_up_y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> world_up_z</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-multiply" title="cogl_matrix_multiply ()">cogl_matrix_multiply</a>                (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *result</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *a</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *b</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-rotate" title="cogl_matrix_rotate ()">cogl_matrix_rotate</a>                  (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> angle</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-rotate-quaternion" title="cogl_matrix_rotate_quaternion ()">cogl_matrix_rotate_quaternion</a>       (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-rotate-euler" title="cogl_matrix_rotate_euler ()">cogl_matrix_rotate_euler</a>            (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-translate" title="cogl_matrix_translate ()">cogl_matrix_translate</a>               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-scale" title="cogl_matrix_scale ()">cogl_matrix_scale</a>                   (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> sx</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> sy</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> sz</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-transpose" title="cogl_matrix_transpose ()">cogl_matrix_transpose</a>               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);
const <span class="returnvalue">float</span> *       <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-get-array" title="cogl_matrix_get_array ()">cogl_matrix_get_array</a>               (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-get-inverse" title="cogl_matrix_get_inverse ()">cogl_matrix_get_inverse</a>             (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *inverse</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-transform-point" title="cogl_matrix_transform_point ()">cogl_matrix_transform_point</a>         (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> *x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> *y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> *z</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> *w</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-transform-points" title="cogl_matrix_transform_points ()">cogl_matrix_transform_points</a>        (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> n_components</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> stride_in</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *points_in</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> stride_out</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *points_out</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> n_points</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-project-points" title="cogl_matrix_project_points ()">cogl_matrix_project_points</a>          (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> n_components</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> stride_in</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *points_in</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> stride_out</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *points_out</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> n_points</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-is-identity" title="cogl_matrix_is_identity ()">cogl_matrix_is_identity</a>             (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);
</pre>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-Matrices.description"></a><h2>Description</h2>
<p>
Matrices are used in Cogl to describe affine model-view transforms, texture
transforms, and projective transforms. This exposes a utility API that can
be used for direct manipulation of these matrices.
</p>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-Matrices.details"></a><h2>Details</h2>
<div class="refsect2">
<a name="CoglMatrix"></a><h3>CoglMatrix</h3>
<pre class="programlisting">typedef struct {
  /* column 0 */
  float xx;
  float yx;
  float zx;
  float wx;

  /* column 1 */
  float xy;
  float yy;
  float zy;
  float wy;

  /* column 2 */
  float xz;
  float yz;
  float zz;
  float wz;

  /* column 3 */
  float xw;
  float yw;
  float zw;
  float ww;
} CoglMatrix;
</pre>
<p>
A CoglMatrix holds a 4x4 transform matrix. This is a single precision,
column-major matrix which means it is compatible with what OpenGL expects.
</p>
<p>
A CoglMatrix can represent transforms such as, rotations, scaling,
translation, sheering, and linear projections. You can combine these
transforms by multiplying multiple matrices in the order you want them
applied.
</p>
<p>
The transformation of a vertex (x, y, z, w) by a CoglMatrix is given by:
</p>
<p>
</p>
<div class="informalexample">
  <table class="listing_frame" border="0" cellpadding="0" cellspacing="0">
    <tbody>
      <tr>
        <td class="listing_lines" align="right"><pre>1
2
3
4</pre></td>
        <td class="listing_code"><pre class="programlisting"><span class="normal">x_new </span><span class="symbol">=</span><span class="normal"> xx </span><span class="symbol">*</span><span class="normal"> x </span><span class="symbol">+</span><span class="normal"> xy </span><span class="symbol">*</span><span class="normal"> y </span><span class="symbol">+</span><span class="normal"> xz </span><span class="symbol">*</span><span class="normal"> z </span><span class="symbol">+</span><span class="normal"> xw </span><span class="symbol">*</span><span class="normal"> w</span>
<span class="normal">y_new </span><span class="symbol">=</span><span class="normal"> yx </span><span class="symbol">*</span><span class="normal"> x </span><span class="symbol">+</span><span class="normal"> yy </span><span class="symbol">*</span><span class="normal"> y </span><span class="symbol">+</span><span class="normal"> yz </span><span class="symbol">*</span><span class="normal"> z </span><span class="symbol">+</span><span class="normal"> yw </span><span class="symbol">*</span><span class="normal"> w</span>
<span class="normal">z_new </span><span class="symbol">=</span><span class="normal"> zx </span><span class="symbol">*</span><span class="normal"> x </span><span class="symbol">+</span><span class="normal"> zy </span><span class="symbol">*</span><span class="normal"> y </span><span class="symbol">+</span><span class="normal"> zz </span><span class="symbol">*</span><span class="normal"> z </span><span class="symbol">+</span><span class="normal"> zw </span><span class="symbol">*</span><span class="normal"> w</span>
<span class="normal">w_new </span><span class="symbol">=</span><span class="normal"> wx </span><span class="symbol">*</span><span class="normal"> x </span><span class="symbol">+</span><span class="normal"> wy </span><span class="symbol">*</span><span class="normal"> y </span><span class="symbol">+</span><span class="normal"> wz </span><span class="symbol">*</span><span class="normal"> z </span><span class="symbol">+</span><span class="normal"> ww </span><span class="symbol">*</span><span class="normal"> w</span></pre></td>
      </tr>
    </tbody>
  </table>
</div>

<p>
</p>
<p>
Where w is normally 1
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>You must consider the members of the CoglMatrix structure read only,
and all matrix modifications must be done via the cogl_matrix API. This
allows Cogl to annotate the matrices internally. Violation of this will give
undefined results. If you need to initialize a matrix with a constant other
than the identity matrix you can use <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-init-from-array" title="cogl_matrix_init_from_array ()"><code class="function">cogl_matrix_init_from_array()</code></a>.</div>
<p>
</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-init-identity"></a><h3>cogl_matrix_init_identity ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_init_identity           (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);</pre>
<p>
Resets matrix to the identity matrix:
</p>
<p>
</p>
<div class="informalexample">
  <table class="listing_frame" border="0" cellpadding="0" cellspacing="0">
    <tbody>
      <tr>
        <td class="listing_lines" align="right"><pre>1
2
3
4</pre></td>
        <td class="listing_code"><pre class="programlisting"><span class="symbol">.</span><span class="normal">xx</span><span class="symbol">=</span><span class="number">1</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">xy</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">xz</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">xw</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span>
<span class="symbol">.</span><span class="normal">yx</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">yy</span><span class="symbol">=</span><span class="number">1</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">yz</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">yw</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span>
<span class="symbol">.</span><span class="normal">zx</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">zy</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">zz</span><span class="symbol">=</span><span class="number">1</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">zw</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span>
<span class="symbol">.</span><span class="normal">wx</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">wy</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">wz</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">ww</span><span class="symbol">=</span><span class="number">1</span><span class="symbol">;</span></pre></td>
      </tr>
    </tbody>
  </table>
</div>

<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr></tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-init-from-array"></a><h3>cogl_matrix_init_from_array ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_init_from_array         (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code>const <span class="type">float</span> *array</code></em>);</pre>
<p>
Initializes <em class="parameter"><code>matrix</code></em> with the contents of <em class="parameter"><code>array</code></em>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>array</code></em> :</span></p></td>
<td>A linear array of 16 floats (column-major order)</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-init-translation"></a><h3>cogl_matrix_init_translation ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_init_translation        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> tx</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> ty</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> tz</code></em>);</pre>
<p>
Resets matrix to the (tx, ty, tz) translation matrix:
</p>
<p>
</p>
<div class="informalexample">
  <table class="listing_frame" border="0" cellpadding="0" cellspacing="0">
    <tbody>
      <tr>
        <td class="listing_lines" align="right"><pre>1
2
3
4</pre></td>
        <td class="listing_code"><pre class="programlisting"><span class="symbol">.</span><span class="normal">xx</span><span class="symbol">=</span><span class="number">1</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">xy</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">xz</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">xw</span><span class="symbol">=</span><span class="normal">tx</span><span class="symbol">;</span>
<span class="symbol">.</span><span class="normal">yx</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">yy</span><span class="symbol">=</span><span class="number">1</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">yz</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">yw</span><span class="symbol">=</span><span class="normal">ty</span><span class="symbol">;</span>
<span class="symbol">.</span><span class="normal">zx</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">zy</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">zz</span><span class="symbol">=</span><span class="number">1</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">zw</span><span class="symbol">=</span><span class="normal">tz</span><span class="symbol">;</span>
<span class="symbol">.</span><span class="normal">wx</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">wy</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">wz</span><span class="symbol">=</span><span class="number">0</span><span class="symbol">;</span><span class="normal"> </span><span class="symbol">.</span><span class="normal">ww</span><span class="symbol">=</span><span class="number">1</span><span class="symbol">;</span></pre></td>
      </tr>
    </tbody>
  </table>
</div>

<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>tx</code></em> :</span></p></td>
<td>x coordinate of the translation vector</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>ty</code></em> :</span></p></td>
<td>y coordinate of the translation vector</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>tz</code></em> :</span></p></td>
<td>z coordinate of the translation vector</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-init-from-quaternion"></a><h3>cogl_matrix_init_from_quaternion ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_init_from_quaternion    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);</pre>
<p>
Initializes <em class="parameter"><code>matrix</code></em> from a <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> rotation.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-init-from-euler"></a><h3>cogl_matrix_init_from_euler ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_init_from_euler         (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>);</pre>
<p>
Initializes <em class="parameter"><code>matrix</code></em> from a <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> rotation.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>euler</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a>
</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-copy"></a><h3>cogl_matrix_copy ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="returnvalue">CoglMatrix</span></a> *        cogl_matrix_copy                    (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);</pre>
<p>
Allocates a new <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> on the heap and initializes it with
the same values as <em class="parameter"><code>matrix</code></em>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix you want to copy</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A newly allocated <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> which
should be freed using <a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-free" title="cogl_matrix_free ()"><code class="function">cogl_matrix_free()</code></a>. <span class="annotation">[<acronym title="Free data after the code is done."><span class="acronym">transfer full</span></acronym>]</span>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.6</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-equal"></a><h3>cogl_matrix_equal ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_matrix_equal                   (<em class="parameter"><code>const <span class="type">void</span> *v1</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *v2</code></em>);</pre>
<p>
Compares two matrices to see if they represent the same
transformation. Although internally the matrices may have different
annotations associated with them and may potentially have a cached
inverse matrix these are not considered in the comparison.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>v1</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>v2</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.4</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-free"></a><h3>cogl_matrix_free ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_free                    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);</pre>
<p>
Frees a <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> that was previously allocated via a call to
<a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-copy" title="cogl_matrix_copy ()"><code class="function">cogl_matrix_copy()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix you want to free</td>
</tr></tbody>
</table></div>
<p class="since">Since 1.6</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-frustum"></a><h3>cogl_matrix_frustum ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_frustum                 (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> left</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> right</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> bottom</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> top</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z_near</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z_far</code></em>);</pre>
<p>
Multiplies <em class="parameter"><code>matrix</code></em> by the given frustum perspective matrix.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>left</code></em> :</span></p></td>
<td>X position of the left clipping plane where it
intersects the near clipping plane</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>right</code></em> :</span></p></td>
<td>X position of the right clipping plane where it
intersects the near clipping plane</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>bottom</code></em> :</span></p></td>
<td>Y position of the bottom clipping plane where it
intersects the near clipping plane</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>top</code></em> :</span></p></td>
<td>Y position of the top clipping plane where it intersects
the near clipping plane</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>z_near</code></em> :</span></p></td>
<td>The distance to the near clipping plane (Must be positive)</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>z_far</code></em> :</span></p></td>
<td>The distance to the far clipping plane (Must be positive)</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-orthographic"></a><h3>cogl_matrix_orthographic ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_orthographic            (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x_1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y_1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x_2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y_2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> near</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> far</code></em>);</pre>
<p>
Multiplies <em class="parameter"><code>matrix</code></em> by a parallel projection matrix.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>x_1</code></em> :</span></p></td>
<td>The x coordinate for the first vertical clipping plane</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y_1</code></em> :</span></p></td>
<td>The y coordinate for the first horizontal clipping plane</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>x_2</code></em> :</span></p></td>
<td>The x coordinate for the second vertical clipping plane</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y_2</code></em> :</span></p></td>
<td>The y coordinate for the second horizontal clipping plane</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>near</code></em> :</span></p></td>
<td>The <span class="emphasis"><em>distance</em></span> to the near clipping
plane (will be <span class="emphasis"><em>negative</em></span> if the plane is
behind the viewer)</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>far</code></em> :</span></p></td>
<td>The <span class="emphasis"><em>distance</em></span> to the far clipping
plane (will be <span class="emphasis"><em>negative</em></span> if the plane is
behind the viewer)</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-perspective"></a><h3>cogl_matrix_perspective ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_perspective             (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> fov_y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> aspect</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z_near</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z_far</code></em>);</pre>
<p>
Multiplies <em class="parameter"><code>matrix</code></em> by the described perspective matrix
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>You should be careful not to have to great a <em class="parameter"><code>z_far</code></em> / <em class="parameter"><code>z_near</code></em>
ratio since that will reduce the effectiveness of depth testing
since there wont be enough precision to identify the depth of
objects near to each other.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>fov_y</code></em> :</span></p></td>
<td>Vertical field of view angle in degrees.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>aspect</code></em> :</span></p></td>
<td>The (width over height) aspect ratio for display</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>z_near</code></em> :</span></p></td>
<td>The distance to the near clipping plane (Must be positive,
and must not be 0)</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>z_far</code></em> :</span></p></td>
<td>The distance to the far clipping plane (Must be positive)</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-look-at"></a><h3>cogl_matrix_look_at ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_look_at                 (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> eye_position_x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> eye_position_y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> eye_position_z</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> object_x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> object_y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> object_z</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> world_up_x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> world_up_y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> world_up_z</code></em>);</pre>
<p>
Applies a view transform <em class="parameter"><code>matrix</code></em> that positions the camera at
the coordinate (<em class="parameter"><code>eye_position_x</code></em>, <em class="parameter"><code>eye_position_y</code></em>, <em class="parameter"><code>eye_position_z</code></em>)
looking towards an object at the coordinate (<em class="parameter"><code>object_x</code></em>, <em class="parameter"><code>object_y</code></em>,
<em class="parameter"><code>object_z</code></em>). The top of the camera is aligned to the given world up
vector, which is normally simply (0, 1, 0) to map up to the
positive direction of the y axis.
</p>
<p>
Because there is a lot of missleading documentation online for
gluLookAt regarding the up vector we want to try and be a bit
clearer here.
</p>
<p>
The up vector should simply be relative to your world coordinates
and does not need to change as you move the eye and object
positions.  Many online sources may claim that the up vector needs
to be perpendicular to the vector between the eye and object
position (partly because the man page is somewhat missleading) but
that is not necessary for this function.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>You should never look directly along the world-up
vector.</div>
<p>
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>It is assumed you are using a typical projection matrix where
your origin maps to the center of your viewport.</div>
<p>
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Almost always when you use this function it should be the first
transform applied to a new modelview transform</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>eye_position_x</code></em> :</span></p></td>
<td>The X coordinate to look from</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>eye_position_y</code></em> :</span></p></td>
<td>The Y coordinate to look from</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>eye_position_z</code></em> :</span></p></td>
<td>The Z coordinate to look from</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>object_x</code></em> :</span></p></td>
<td>The X coordinate of the object to look at</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>object_y</code></em> :</span></p></td>
<td>The Y coordinate of the object to look at</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>object_z</code></em> :</span></p></td>
<td>The Z coordinate of the object to look at</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>world_up_x</code></em> :</span></p></td>
<td>The X component of the world's up direction vector</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>world_up_y</code></em> :</span></p></td>
<td>The Y component of the world's up direction vector</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>world_up_z</code></em> :</span></p></td>
<td>The Z component of the world's up direction vector</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.8</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-multiply"></a><h3>cogl_matrix_multiply ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_multiply                (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *result</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *a</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *b</code></em>);</pre>
<p>
Multiplies the two supplied matrices together and stores
the resulting matrix inside <em class="parameter"><code>result</code></em>.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>It is possible to multiply the <em class="parameter"><code>a</code></em> matrix in-place, so
<em class="parameter"><code>result</code></em> can be equal to <em class="parameter"><code>a</code></em> but can't be equal to <em class="parameter"><code>b</code></em>.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>result</code></em> :</span></p></td>
<td>The address of a 4x4 matrix to store the result in</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>a</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>b</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-rotate"></a><h3>cogl_matrix_rotate ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_rotate                  (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> angle</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z</code></em>);</pre>
<p>
Multiplies <em class="parameter"><code>matrix</code></em> with a rotation matrix that applies a rotation
of <em class="parameter"><code>angle</code></em> degrees around the specified 3D vector.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>angle</code></em> :</span></p></td>
<td>The angle you want to rotate in degrees</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>x</code></em> :</span></p></td>
<td>X component of your rotation vector</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y</code></em> :</span></p></td>
<td>Y component of your rotation vector</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>z</code></em> :</span></p></td>
<td>Z component of your rotation vector</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-rotate-quaternion"></a><h3>cogl_matrix_rotate_quaternion ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_rotate_quaternion       (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);</pre>
<p>
Multiplies <em class="parameter"><code>matrix</code></em> with a rotation transformation described by the
given <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>A quaternion describing a rotation</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-rotate-euler"></a><h3>cogl_matrix_rotate_euler ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_rotate_euler            (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>);</pre>
<p>
Multiplies <em class="parameter"><code>matrix</code></em> with a rotation transformation described by the
given <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>euler</code></em> :</span></p></td>
<td>A euler describing a rotation</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-translate"></a><h3>cogl_matrix_translate ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_translate               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z</code></em>);</pre>
<p>
Multiplies <em class="parameter"><code>matrix</code></em> with a transform matrix that translates along
the X, Y and Z axis.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>x</code></em> :</span></p></td>
<td>The X translation you want to apply</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y</code></em> :</span></p></td>
<td>The Y translation you want to apply</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>z</code></em> :</span></p></td>
<td>The Z translation you want to apply</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-scale"></a><h3>cogl_matrix_scale ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_scale                   (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> sx</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> sy</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> sz</code></em>);</pre>
<p>
Multiplies <em class="parameter"><code>matrix</code></em> with a transform matrix that scales along the X,
Y and Z axis.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>sx</code></em> :</span></p></td>
<td>The X scale factor</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>sy</code></em> :</span></p></td>
<td>The Y scale factor</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>sz</code></em> :</span></p></td>
<td>The Z scale factor</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-transpose"></a><h3>cogl_matrix_transpose ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_transpose               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);</pre>
<p>
Replaces <em class="parameter"><code>matrix</code></em> with its transpose. Ie, every element (i,j) in the
new matrix is taken from element (j,i) in the old matrix.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a>
</td>
</tr></tbody>
</table></div>
<p class="since">Since 1.10</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-get-array"></a><h3>cogl_matrix_get_array ()</h3>
<pre class="programlisting">const <span class="returnvalue">float</span> *       cogl_matrix_get_array               (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);</pre>
<p>
Casts <em class="parameter"><code>matrix</code></em> to a float array which can be directly passed to OpenGL.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>a pointer to the float array</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-get-inverse"></a><h3>cogl_matrix_get_inverse ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_matrix_get_inverse             (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *inverse</code></em>);</pre>
<p>
Gets the inverse transform of a given matrix and uses it to initialize
a new <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a>.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Although the first parameter is annotated as const to indicate
that the transform it represents isn't modified this function may
technically save a copy of the inverse transform within the given
<a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> so that subsequent requests for the inverse transform may
avoid costly inversion calculations.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>inverse</code></em> :</span></p></td>
<td>The destination for a 4x4 inverse transformation matrix. <span class="annotation">[<acronym title="Parameter for returning results. Default is transfer full."><span class="acronym">out</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if the inverse was successfully calculated or <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a>
for degenerate transformations that can't be inverted (in this case the
<em class="parameter"><code>inverse</code></em> matrix will simply be initialized with the identity matrix)</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.2</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-transform-point"></a><h3>cogl_matrix_transform_point ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_transform_point         (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> *x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> *y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> *z</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> *w</code></em>);</pre>
<p>
Transforms a point whos position is given and returned as four float
components.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A 4x4 transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>x</code></em> :</span></p></td>
<td>The X component of your points position. <span class="annotation">[<acronym title="Parameter for input and for returning results. Default is transfer full."><span class="acronym">inout</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y</code></em> :</span></p></td>
<td>The Y component of your points position. <span class="annotation">[<acronym title="Parameter for input and for returning results. Default is transfer full."><span class="acronym">inout</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>z</code></em> :</span></p></td>
<td>The Z component of your points position. <span class="annotation">[<acronym title="Parameter for input and for returning results. Default is transfer full."><span class="acronym">inout</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>w</code></em> :</span></p></td>
<td>The W component of your points position. <span class="annotation">[<acronym title="Parameter for input and for returning results. Default is transfer full."><span class="acronym">inout</span></acronym>]</span>
</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-transform-points"></a><h3>cogl_matrix_transform_points ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_transform_points        (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> n_components</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> stride_in</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *points_in</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> stride_out</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *points_out</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> n_points</code></em>);</pre>
<p>
Transforms an array of input points and writes the result to
another array of output points. The input points can either have 2
or 3 components each. The output points always have 3 components.
The output array can simply point to the input array to do the
transform in-place.
</p>
<p>
If you need to transform 4 component points see
<a class="link" href="cogl-2.0-experimental-Matrices.html#cogl-matrix-project-points" title="cogl_matrix_project_points ()"><code class="function">cogl_matrix_project_points()</code></a>.
</p>
<p>
Here's an example with differing input/output strides:
</p>
<div class="informalexample">
  <table class="listing_frame" border="0" cellpadding="0" cellspacing="0">
    <tbody>
      <tr>
        <td class="listing_lines" align="right"><pre>1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23</pre></td>
        <td class="listing_code"><pre class="programlisting"><span class="keyword">typedef</span><span class="normal"> </span><span class="keyword">struct</span><span class="normal"> </span><span class="cbracket">{</span>
<span class="normal">  </span><span class="type">float</span><span class="normal"> x</span><span class="symbol">,</span><span class="normal">y</span><span class="symbol">;</span>
<span class="normal">  </span><span class="usertype">uint8_t</span><span class="normal"> r</span><span class="symbol">,</span><span class="normal">g</span><span class="symbol">,</span><span class="normal">b</span><span class="symbol">,</span><span class="normal">a</span><span class="symbol">;</span>
<span class="normal">  </span><span class="type">float</span><span class="normal"> s</span><span class="symbol">,</span><span class="normal">t</span><span class="symbol">,</span><span class="normal">p</span><span class="symbol">;</span>
<span class="cbracket">}</span><span class="normal"> MyInVertex</span><span class="symbol">;</span>
<span class="keyword">typedef</span><span class="normal"> </span><span class="keyword">struct</span><span class="normal"> </span><span class="cbracket">{</span>
<span class="normal">  </span><span class="usertype">uint8_t</span><span class="normal"> r</span><span class="symbol">,</span><span class="normal">g</span><span class="symbol">,</span><span class="normal">b</span><span class="symbol">,</span><span class="normal">a</span><span class="symbol">;</span>
<span class="normal">  </span><span class="type">float</span><span class="normal"> x</span><span class="symbol">,</span><span class="normal">y</span><span class="symbol">,</span><span class="normal">z</span><span class="symbol">;</span>
<span class="cbracket">}</span><span class="normal"> MyOutVertex</span><span class="symbol">;</span>
<span class="usertype">MyInVertex</span><span class="normal"> vertices</span><span class="symbol">[</span><span class="normal">N_VERTICES</span><span class="symbol">];</span>
<span class="usertype">MyOutVertex</span><span class="normal"> results</span><span class="symbol">[</span><span class="normal">N_VERTICES</span><span class="symbol">];</span>
<span class="usertype">CoglMatrix</span><span class="normal"> matrix</span><span class="symbol">;</span>

<span class="function">my_load_vertices</span><span class="normal"> </span><span class="symbol">(</span><span class="normal">vertices</span><span class="symbol">);</span>
<span class="function">my_get_matrix</span><span class="normal"> </span><span class="symbol">(&amp;</span><span class="normal">matrix</span><span class="symbol">);</span>

<span class="function"><a href="cogl-2.0-experimental-Matrices.html#cogl-matrix-transform-points">cogl_matrix_transform_points</a></span><span class="normal"> </span><span class="symbol">(&amp;</span><span class="normal">matrix</span><span class="symbol">,</span>
<span class="normal">                              </span><span class="number">2</span><span class="symbol">,</span>
<span class="normal">                              </span><span class="keyword">sizeof</span><span class="normal"> </span><span class="symbol">(</span><span class="normal">MyInVertex</span><span class="symbol">),</span>
<span class="normal">                              </span><span class="symbol">&amp;</span><span class="normal">vertices</span><span class="symbol">[</span><span class="number">0</span><span class="symbol">].</span><span class="normal">x</span><span class="symbol">,</span>
<span class="normal">                              </span><span class="keyword">sizeof</span><span class="normal"> </span><span class="symbol">(</span><span class="normal">MyOutVertex</span><span class="symbol">),</span>
<span class="normal">                              </span><span class="symbol">&amp;</span><span class="normal">results</span><span class="symbol">[</span><span class="number">0</span><span class="symbol">].</span><span class="normal">x</span><span class="symbol">,</span>
<span class="normal">                              N_VERTICES</span><span class="symbol">);</span></pre></td>
      </tr>
    </tbody>
  </table>
</div>

<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A transformation matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>n_components</code></em> :</span></p></td>
<td>The number of position components for each input point.
(either 2 or 3)</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>stride_in</code></em> :</span></p></td>
<td>The stride in bytes between input points.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>points_in</code></em> :</span></p></td>
<td>A pointer to the first component of the first input point.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>stride_out</code></em> :</span></p></td>
<td>The stride in bytes between output points.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>points_out</code></em> :</span></p></td>
<td>A pointer to the first component of the first output point.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>n_points</code></em> :</span></p></td>
<td>The number of points to transform.</td>
</tr>
</tbody>
</table></div>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-project-points"></a><h3>cogl_matrix_project_points ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_matrix_project_points          (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> n_components</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> stride_in</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *points_in</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> stride_out</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *points_out</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> n_points</code></em>);</pre>
<p>
Projects an array of input points and writes the result to another
array of output points. The input points can either have 2, 3 or 4
components each. The output points always have 4 components (known
as homogenous coordinates). The output array can simply point to
the input array to do the transform in-place.
</p>
<p>
Here's an example with differing input/output strides:
</p>
<div class="informalexample">
  <table class="listing_frame" border="0" cellpadding="0" cellspacing="0">
    <tbody>
      <tr>
        <td class="listing_lines" align="right"><pre>1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23</pre></td>
        <td class="listing_code"><pre class="programlisting"><span class="keyword">typedef</span><span class="normal"> </span><span class="keyword">struct</span><span class="normal"> </span><span class="cbracket">{</span>
<span class="normal">  </span><span class="type">float</span><span class="normal"> x</span><span class="symbol">,</span><span class="normal">y</span><span class="symbol">;</span>
<span class="normal">  </span><span class="usertype">uint8_t</span><span class="normal"> r</span><span class="symbol">,</span><span class="normal">g</span><span class="symbol">,</span><span class="normal">b</span><span class="symbol">,</span><span class="normal">a</span><span class="symbol">;</span>
<span class="normal">  </span><span class="type">float</span><span class="normal"> s</span><span class="symbol">,</span><span class="normal">t</span><span class="symbol">,</span><span class="normal">p</span><span class="symbol">;</span>
<span class="cbracket">}</span><span class="normal"> MyInVertex</span><span class="symbol">;</span>
<span class="keyword">typedef</span><span class="normal"> </span><span class="keyword">struct</span><span class="normal"> </span><span class="cbracket">{</span>
<span class="normal">  </span><span class="usertype">uint8_t</span><span class="normal"> r</span><span class="symbol">,</span><span class="normal">g</span><span class="symbol">,</span><span class="normal">b</span><span class="symbol">,</span><span class="normal">a</span><span class="symbol">;</span>
<span class="normal">  </span><span class="type">float</span><span class="normal"> x</span><span class="symbol">,</span><span class="normal">y</span><span class="symbol">,</span><span class="normal">z</span><span class="symbol">;</span>
<span class="cbracket">}</span><span class="normal"> MyOutVertex</span><span class="symbol">;</span>
<span class="usertype">MyInVertex</span><span class="normal"> vertices</span><span class="symbol">[</span><span class="normal">N_VERTICES</span><span class="symbol">];</span>
<span class="usertype">MyOutVertex</span><span class="normal"> results</span><span class="symbol">[</span><span class="normal">N_VERTICES</span><span class="symbol">];</span>
<span class="usertype">CoglMatrix</span><span class="normal"> matrix</span><span class="symbol">;</span>

<span class="function">my_load_vertices</span><span class="normal"> </span><span class="symbol">(</span><span class="normal">vertices</span><span class="symbol">);</span>
<span class="function">my_get_matrix</span><span class="normal"> </span><span class="symbol">(&amp;</span><span class="normal">matrix</span><span class="symbol">);</span>

<span class="function"><a href="cogl-2.0-experimental-Matrices.html#cogl-matrix-project-points">cogl_matrix_project_points</a></span><span class="normal"> </span><span class="symbol">(&amp;</span><span class="normal">matrix</span><span class="symbol">,</span>
<span class="normal">                            </span><span class="number">2</span><span class="symbol">,</span>
<span class="normal">                            </span><span class="keyword">sizeof</span><span class="normal"> </span><span class="symbol">(</span><span class="normal">MyInVertex</span><span class="symbol">),</span>
<span class="normal">                            </span><span class="symbol">&amp;</span><span class="normal">vertices</span><span class="symbol">[</span><span class="number">0</span><span class="symbol">].</span><span class="normal">x</span><span class="symbol">,</span>
<span class="normal">                            </span><span class="keyword">sizeof</span><span class="normal"> </span><span class="symbol">(</span><span class="normal">MyOutVertex</span><span class="symbol">),</span>
<span class="normal">                            </span><span class="symbol">&amp;</span><span class="normal">results</span><span class="symbol">[</span><span class="number">0</span><span class="symbol">].</span><span class="normal">x</span><span class="symbol">,</span>
<span class="normal">                            N_VERTICES</span><span class="symbol">);</span></pre></td>
      </tr>
    </tbody>
  </table>
</div>

<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A projection matrix</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>n_components</code></em> :</span></p></td>
<td>The number of position components for each input point.
(either 2, 3 or 4)</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>stride_in</code></em> :</span></p></td>
<td>The stride in bytes between input points.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>points_in</code></em> :</span></p></td>
<td>A pointer to the first component of the first input point.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>stride_out</code></em> :</span></p></td>
<td>The stride in bytes between output points.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>points_out</code></em> :</span></p></td>
<td>A pointer to the first component of the first output point.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>n_points</code></em> :</span></p></td>
<td>The number of points to transform.</td>
</tr>
</tbody>
</table></div>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-matrix-is-identity"></a><h3>cogl_matrix_is_identity ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_matrix_is_identity             (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);</pre>
<p>
Determines if the given matrix is an identity matrix.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if <em class="parameter"><code>matrix</code></em> is an identity matrix else <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.8</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18.1</div>
</body>
</html>